#include <Arduino.h>
#include <Wire.h>
#include <SoftwareSerial.h>

int varArmed = 0;

void _delay(float seconds) {
  long endTime = millis() + seconds * 1000;
  while(millis() < endTime) _alarm();
}

void setup() {
  pinMode(0,OUTPUT); // pin 5 on IC - alarm output goes to horn relay
  pinMode(1,INPUT); //pin 6 on IC - to door handle switches N/C high input 
  pinMode(2,OUTPUT); //pin 7 on IC - Armed LED
  pinMode(3,INPUT); //pin 2 on IC - to door unlock High pulse Turn off alarm
  pinMode(4,INPUT); //pin 3 on IC - to door lock High pulse Turn on alarm

  digitalWrite(0,0); // Alarm off when powered up

  while(varArmed == 0) {
      //do nothing but wait until arm and make sure it does not sound alarm

      digitalWrite(0,0); //ensure alarm output is off
      digitalWrite(2,0); //armed led off

      if(digitalRead(4) == 1){   //when doors lock signal goes high temporarily, arm alarm    
        varArmed = 1;
      }
      _loop();
  }

    while(varArmed == 1) { //alarm armed routine

      digitalWrite(2,1); //armed led on

      if(digitalRead(3) == 1){ //when doors unlock signal goes high temporarily, disarm alarm
        varArmed = 0;
      }

      //check to see if alarm is triggered
      if(digitalRead(1) == 0){ // N/C switch opens pulling input low
        //Alarm triggered routine

        digitalWrite(0,1);
        _delay(5);
        digitalWrite(0,0);// turn alarm off when 5 seconds up ready to go again
      }

      _loop();
    }

    setup();

}
void _alarm() { // once alarm triggers, if disarmed it turns off alarm

      if(digitalRead(3) == 1){ //when doors unlock signal goes high temporarily, disarm alarm instantly
        varArmed = 0;
        digitalWrite(0,0); //turn alarm off
        setup();
      }

}

void alarm() {
  _alarm();
}

void _loop() {
}

void loop() {
  _loop();
}